@page "/Statistics/Catches"
@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@inject IJSRuntime JSRuntime
@using BioMap
@using BioMap.Shared
@using ChartJs.Blazor.Common.Enums
@using ChartJs.Blazor.Common.Axes
@using ChartJs.Blazor.Common.Axes.Ticks
@using ChartJs.Blazor.Common
@using ChartJs.Blazor.Common.Handlers
@using ChartJs.Blazor.Common.Time
@using ChartJs.Blazor.LineChart
@using ChartJs.Blazor.BarChart
@using ChartJs.Blazor.BarChart.Axes
@inherits ProtectedPage

<div class="box">
  <div class="row header">
    <FilterSettings FilteringTarget="@Filters.FilteringTargetEnum.Catches" />
  </div>
  <div class="row content">

    <h1>@Localize["Catches"]</h1>

    <Tabs SelectedTab="@selectedTab" SelectedTabChanged="@OnSelectedTabChanged" Pills="true">
      <Items>
        <Tab Name="OverTime">@Localize["Catch numbers over time"]</Tab>
        <Tab Name="PerMonth">@Localize["Catch numbers per month"]</Tab>
        <Tab Name="HeadBodyLength">@Localize["Head-body-length of all catches"]</Tab>
        <Tab Name="GenderRatio">@Localize["Gender"]</Tab>
        <Tab Name="GenderRatioPerAnno">@Localize["Gender per anno"]</Tab>
        <Tab Name="MigrationDistances">@Localize["Migration distances"]</Tab>
        <Tab Name="MigrationByAge">@Localize["Migration by age"]</Tab>
        <Tab Name="SeasonTiming">@Localize["Season timing"]</Tab>
      </Items>
      <Content>
        <TabPanel Name="OverTime">
          <Row>
            <Column>
              @Localize["Die Fangzahlen pro Monat, aufgeschlüsselt nach dem Alter (Überwinterungen) der gefangenen Individuen. Zusätzlich sind Monatsmittelwerte von Temperatur und Niederschlagsmenge angegeben."]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsOverTime" Config="@_configOverTime" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartOverTime" RowLabel="@Localize["Month"]" _config="@_configOverTime" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="PerMonth">
          <Row>
            <Column>
              @Localize["Catch numbers per month summed over all years, broken down by age (overwintering) of individuals caught. In addition, monthly mean values of temperature and precipitation are given."]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsPerMonth" Config="@_configPerMonth" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartPerMonth" RowLabel="@Localize["Month"]" _config="@_configPerMonth" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="HeadBodyLength">
          <Row>
            <Column>
              @Localize["The frequency distribution of head-torso lengths of all catches, broken down by age (overwintering) of the individuals caught."]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsHeadBodyLength" Config="@_configHeadBodyLength" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartHeadBodyLength" RowLabel="@(Localize["Length"]+" / mm")" _config="@_configHeadBodyLength" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="GenderRatio">
          <Row>
            <Column>
              @Localize["Catch numbers per month summed over all years. Only individuals with the sex information 'f' or 'm' and 1+ hibernations are counted. If the total is less than 10, the percentage value is set to 50% to avoid outliers."]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsGenderRatio" Config="@_configGenderRatio" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartGenderRatio" RowLabel="@(Localize["Month"])" _config="@_configGenderRatio" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="GenderRatioPerAnno">
          <Row>
            <Column>
              @Localize["Catch numbers per year. Only individuals with the sex information 'f' or 'm' and 1+ hibernations are counted."]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsGenderRatioPerAnno" Config="@_configGenderRatioPerAnno" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartGenderRatioPerAnno" RowLabel="@(Localize["Month"])" _config="@_configGenderRatioPerAnno" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="MigrationDistances">
          <Row>
            <Column>
              @Localize["Frequency distribution of migratory distances of all captures, broken down by age (overwintering) of individuals captured. The migration distance is measured from the previous catch of the same individual."]
            </Column>
            <Column ColumnSize="ColumnSize.Is3">
              <CheckBox @bind-Checked="@RelativeMigrationCounts" LabelText=@Localize["Relative"] />
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsMigrationDistances" Config="@_configMigrationDistances" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartMigrationDistances" RowLabel="@(Localize["Distance"]+" / m")" _config="@_configMigrationDistances" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="MigrationByAge">
          <Row>
            <Column>
              @Localize["Statistics_MigrationsByAge_Description"]
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsMigrationByAge" Config="@_configMigrationByAge" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <TableFromChart @ref="_tableFromChartMigrationByAge" RowLabel="@(this.Localize["Hibernations"])" _config="@_configMigrationByAge" />
            </Column>
          </Row>
        </TabPanel>
        <TabPanel Name="SeasonTiming">
          <Row>
            <Column ColumnSize="ColumnSize.Is4">
              @Localize["Season timing"]
            </Column>
            <Column>
              <Field Horizontal="true">
                <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is6.OnDesktop" TextAlignment="TextAlignment.End">@Localize["Sort method"]</FieldLabel>
                <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is6.OnDesktop">
                  <Select TValue="int" SelectedValue="this.sortMethodSeasonTiming" SelectedValueChanged="(value)=>{this.sortMethodSeasonTiming=value;this.RefreshData();this.StateHasChanged();}">
                    <SelectItem Value="0">-</SelectItem>
                    <SelectItem Value="1">@Localize["By season start"]</SelectItem>
                    <SelectItem Value="2">@Localize["By season start width"]</SelectItem>
                  </Select>
                </FieldBody>
              </Field>
            </Column>
          </Row>
          <Row>
            <Column>
              <Chart @ref="_chartJsSeasonTiming" Config="@_configSeasonTiming" Width="600" Height="300" />
            </Column>
          </Row>
          <Row>
            <Column>
              <table class="table table-sm table-striped text-right">
                <thead>
                  <tr>
                    <th scope="col"></th>
                    <th scope="col">@Localize["Over all"]</th>
                    <th scope="col">@Localize["Individual"]</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td scope="col">@Localize["Season start mean value / day of year"]</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonStartDayOverAll.MeanValue, 0)} (N={this.SvSeasonStartDayOverAll.Count})")</td>
                    <td scope="col"></td>
                  </tr>
                  <tr>
                    <td scope="col">@Localize["Season end mean value / day of year"]</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonEndDayOverAll.MeanValue, 0)} (N={this.SvSeasonEndDayOverAll.Count})")</td>
                    <td scope="col"></td>
                  </tr>
                  <tr>
                    <td scope="col">@Localize["Season start standard deviation / days"]</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonStartDayOverAll.StdDeviation, 1)} (N={this.SvSeasonStartDayOverAll.Count})")</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonStartDayIndividualStdDev.MeanValue, 1)} (N={this.SvSeasonStartDayIndividualStdDev.Count})")</td>
                  </tr>
                  <tr>
                    <td scope="col">@Localize["Season end standard deviation / days"]</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonEndDayOverAll.StdDeviation, 1)} (N={this.SvSeasonEndDayOverAll.Count})")</td>
                    <td scope="col">@($"{ConvInvar.ToDecimalString(this.SvSeasonEndDayIndividualStdDev.MeanValue, 1)} (N={this.SvSeasonEndDayIndividualStdDev.Count})")</td>
                  </tr>
                </tbody>
              </table>
            </Column>
          </Row>
        </TabPanel>
      </Content>
    </Tabs>
  </div>
</div>
